﻿/*:
 * @plugindesc 在主菜单中显示变量，用作声望等
 * @author King Revise by Fanzi    https://rpg.blue/
 *
 * @param  WindowPlace
 * @desc 窗口位置：默认左侧填false；用布局插件填true显示下排。
 * @default false
 *
 * @param  VariableNumber
 * @desc 变量ID
 * @default 1
 *
 * @param  ShowText
 * @desc 用途显示
 * @default 声望
 *
 * @param  ShowIcon
 * @desc 显示图标
 * @default 225
 *
 * @param  VariableNumber2
 * @desc 变量ID
 * @default 2
 *
 * @param  ShowText2
 * @desc 用途显示
 * @default 善恶
 *
 * @param  ShowIcon2
 * @desc 显示图标
 * @default 225
 *
 * @param  VariableNumber3
 * @desc 变量ID
 * @default 3
 *
 * @param  ShowText3
 * @desc 用途显示
 * @default 贡献
 *
 * @param  ShowIcon3
 * @desc 显示图标
 * @default 225
 *
 * @help 使用方法：
 * 本插件用在菜单主界面显示变量值，可作为声望等游戏数据，最多显示3个窗口
 * 未使用主菜单布局插件的，请将参数WindowPlace设为false，窗口显示在指令下方
 * 使用了AltMenuScreen插件，请将参数WindowPlace设为true，窗口将显示在下排
 * 若使用了其它菜单布局插件，请自行调整两个插件的布局搭配，或到江湖梦网联系Fanzi
 * 参数VariableNumber可自定义变量ID
 * 参数ShowText可定义该变量的显示意义，留空不显示该窗口
 * 参数ShowIcon可变更显示的图标
 */
WindowPlace = PluginManager.parameters('A_Window_Value')["WindowPlace"].toLowerCase() == 'true';
VariableNumber = parseInt(PluginManager.parameters('A_Window_Value')["VariableNumber"]);
ShowText = String(PluginManager.parameters('A_Window_Value')["ShowText"]);
ShowIcon = parseInt(PluginManager.parameters('A_Window_Value')["ShowIcon"]);
VariableNumber2 = parseInt(PluginManager.parameters('A_Window_Value')["VariableNumber2"]);
ShowText2 = String(PluginManager.parameters('A_Window_Value')["ShowText2"]);
ShowIcon2 = parseInt(PluginManager.parameters('A_Window_Value')["ShowIcon2"]);
VariableNumber3 = parseInt(PluginManager.parameters('A_Window_Value')["VariableNumber3"]);
ShowText3 = String(PluginManager.parameters('A_Window_Value')["ShowText3"]);
ShowIcon3 = parseInt(PluginManager.parameters('A_Window_Value')["ShowIcon3"]);

//创建自定义窗口，并将它加入主菜单界面（窗口位置在此调整）
var _Scene_Menu_create = Scene_Menu.prototype.create;
Scene_Menu.prototype.create = function() {
    _Scene_Menu_create.call(this);

    this._ValueWindow = new Window_Value(0, 0);
    this._Value2Window = new Window_Value2(0, 0);
    this._Value3Window = new Window_Value3(0, 0);
    if (WindowPlace){
        this._ValueWindow.y = Graphics.boxHeight - this._goldWindow.height;
        this._Value2Window.x = this._ValueWindow.x + 240;
        this._Value2Window.y = Graphics.boxHeight - this._goldWindow.height;
        this._Value3Window.x = this._ValueWindow.x + 480;
        this._Value3Window.y = Graphics.boxHeight - this._goldWindow.height;
    } else {
        this._ValueWindow.y = this._commandWindow.y + this._commandWindow.height;
        this._Value2Window.y = this._ValueWindow.y + this._goldWindow.height;
        this._Value3Window.y = this._Value2Window.y + this._goldWindow.height;
    }
//设置自定义窗口的Y坐标，由左上部的菜单命令窗口的Y轴坐标及其高度来决定
    if (ShowText) this.addWindow(this._ValueWindow);
    if (ShowText2) this.addWindow(this._Value2Window);
    if (ShowText3) this.addWindow(this._Value3Window);
};
//单独调用到，把上面这段删除！添加调用方式请参考默认Scene_Menu里面调用金钱窗口的写法
//-----------------------------------------------------------------------------

function Window_Value() {
    this.initialize.apply(this, arguments);
}
function Window_Value2() {
    this.initialize.apply(this, arguments);
}
function Window_Value3() {
    this.initialize.apply(this, arguments);
}
//设置原形 
Window_Value.prototype = Object.create(Window_Base.prototype);
Window_Value2.prototype = Object.create(Window_Base.prototype);
Window_Value3.prototype = Object.create(Window_Base.prototype);
//设置创造者
Window_Value.prototype.constructor = Window_Value;
Window_Value2.prototype.constructor = Window_Value;
Window_Value3.prototype.constructor = Window_Value;
//初始化
Window_Value.prototype.initialize = function(x, y) {
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Base.prototype.initialize.call(this, x, y, width, height);
    this.refresh();
};
Window_Value2.prototype.initialize = function(x, y) {
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Base.prototype.initialize.call(this, x, y, width, height);
    this.refresh();
};
Window_Value3.prototype.initialize = function(x, y) {
    var width = this.windowWidth();
    var height = this.windowHeight();
    Window_Base.prototype.initialize.call(this, x, y, width, height);
    this.refresh();
};
//窗口宽
Window_Value.prototype.windowWidth = function() {
    return 240;
};
Window_Value2.prototype.windowWidth = function() {
    return 240;
};
Window_Value3.prototype.windowWidth = function() {
    return 240;
};
//窗口高
Window_Value.prototype.windowHeight = function() {
    return this.fittingHeight(1);
};
Window_Value2.prototype.windowHeight = function() {
    return this.fittingHeight(1);
};
Window_Value3.prototype.windowHeight = function() {
    return this.fittingHeight(1);
};
//刷新
Window_Value.prototype.refresh = function() {
    var x = this.textPadding();
    var width = this.contents.width - this.textPadding() * 2;
    this.contents.clear();
//在这里绘制需要显示的内容
    this.drawIcon(ShowIcon, 0, 0);
    this.drawTextEx(ShowText+"："+$gameVariables.value(VariableNumber), 40, 0, width, 'center');
};
Window_Value2.prototype.refresh = function() {
    var x = this.textPadding();
    var width = this.contents.width - this.textPadding() * 2;
    this.contents.clear();
//在这里绘制需要显示的内容
    this.drawIcon(ShowIcon2, 0, 0);
    this.drawTextEx(ShowText2+"："+$gameVariables.value(VariableNumber2), 40, 0, width, 'center');
};
Window_Value3.prototype.refresh = function() {
    var x = this.textPadding();
    var width = this.contents.width - this.textPadding() * 2;
    this.contents.clear();
//在这里绘制需要显示的内容
    this.drawIcon(ShowIcon3, 0, 0);
    this.drawTextEx(ShowText3+"："+$gameVariables.value(VariableNumber3), 40, 0, width, 'center');
};
//打开
Window_Value.prototype.open = function() {
    this.refresh();
    Window_Base.prototype.open.call(this);
};
Window_Value2.prototype.open = function() {
    this.refresh();
    Window_Base.prototype.open.call(this);
};
Window_Value3.prototype.open = function() {
    this.refresh();
    Window_Base.prototype.open.call(this);
};