//=============================================================================
// Drill_TroopName.js
//=============================================================================

/*:
 * @plugindesc [v1.0]        敌人 - 敌人命名
 * @author Drill_up
 * 
 * @param 重复敌人后缀名-半字节
 * @type text[]
 * @desc 重复敌人的后缀名命名。
 * @default [" A"," B"," C"," D"," E"," F"," G"," H"," I"," J"," K"," L"," M"," N"," O"," P"," Q"," R"," S"," T"," U"," V"," W"," X"," Y"," Z"]
 * 
 * @param 重复敌人后缀名-全字节
 * @type text[]
 * @desc 重复敌人的后缀名命名。
 * @default ["Ａ","Ｂ","Ｃ","Ｄ","Ｅ","Ｆ","Ｇ","Ｈ","Ｉ","Ｊ","Ｋ","Ｌ","Ｍ","Ｎ","Ｏ","Ｐ","Ｑ","Ｒ","Ｓ","Ｔ","Ｕ","Ｖ","Ｗ","Ｘ","Ｙ","Ｚ"]
 * 
 * @help  
 * =============================================================================
 * +++ Drill_TroopName +++
 * 作者：Drill_up
 * 如果你有兴趣，也可以来看看我的mog中文全翻译插件哦ヽ(*。>Д<)o゜
 * https://rpg.blue/thread-409713-1-1.html
 * =============================================================================
 * 如果战斗中出现重复敌人，你可以在这里设置其后缀。
 *
 * -----------------------------------------------------------------------------
 * ----关于半字节和全字节：
 * 半字节和全字节是为了中文和英文的适应性而设置的，可以把它们设成一样的。
 *
 * -----------------------------------------------------------------------------
 * ----更新日志
 * [v1.0]
 * 完成插件ヽ(*。>Д<)o゜
 */
 
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
//		临时全局变量	DrillUp.xxx
//		临时局部变量	无
//		存储数据变量	无
//		全局存储变量	无
//		覆盖重写方法	无
//
//插件记录：
//		无
//

//=============================================================================
// ** 变量获取
//=============================================================================
　　var Imported = Imported || {};
　　Imported.Drill_TroopName = true;
　　var DrillUp = DrillUp || {}; 

    DrillUp.parameters = PluginManager.parameters('Drill_TroopName');
	if(DrillUp.parameters['重复敌人后缀名-半字节'] != "" ){
		DrillUp.letter_half = JSON.parse(DrillUp.parameters['重复敌人后缀名-半字节']);
	}else{
		DrillUp.letter_half = [
			' A',' B',' C',' D',' E',' F',' G',' H',' I',' J',' K',' L',' M',
			' N',' O',' P',' Q',' R',' S',' T',' U',' V',' W',' X',' Y',' Z'
		];
	}
	if(DrillUp.parameters['重复敌人后缀名-全字节'] != "" ){
		DrillUp.letter_full = JSON.parse(DrillUp.parameters['重复敌人后缀名-全字节']);
	}else{
		DrillUp.letter_full = [
			'Ａ','Ｂ','Ｃ','Ｄ','Ｅ','Ｆ','Ｇ','Ｈ','Ｉ','Ｊ','Ｋ','Ｌ','Ｍ',
			'Ｎ','Ｏ','Ｐ','Ｑ','Ｒ','Ｓ','Ｔ','Ｕ','Ｖ','Ｗ','Ｘ','Ｙ','Ｚ'
		];
	}

//=============================================================================
// ** 复写函数
//=============================================================================

Game_Troop.LETTER_TABLE_HALF = DrillUp.letter_half;
Game_Troop.LETTER_TABLE_FULL = DrillUp.letter_full;

